package client_filterChatByBLID
{
	function filterID(%id)
	{
		%id = mFloatLength(%id, 0);

		if(%id >= 0)
		{
			unfilterID(%id);

			if(getWordCount($Pref::Chat::BLIDsToFilter) > 0)
			{
				$Pref::Chat::BLIDsToFilter = $Pref::Chat::BLIDsToFilter SPC %id;
			}
			else
			{
				$Pref::Chat::BLIDsToFilter = %id;
			}
		}
	}

	function unfilterID(%id)
	{
		%id = mFloatLength(%id, 0);

		if(%id >= 0)
		{
			if(getWordCount($Pref::Chat::BLIDsToFilter) == 1)
			{
				$Pref::Chat::BLIDsToFilter = strreplace($Pref::Chat::BLIDsToFilter, %id, "");
			}
			else if(getWordCount($Pref::Chat::BLIDsToFilter) > 1)
			{
				$Pref::Chat::BLIDsToFilter = strreplace($Pref::Chat::BLIDsToFilter, %id @ " ", "");
				$Pref::Chat::BLIDsToFilter = strreplace($Pref::Chat::BLIDsToFilter, " " @ %id, "");
			}
		}
	}

	function listFilteredIDs()
	{
		echo("FilterChatByBLID: Filtered IDs");

		for(%i = 0;%i < getWordCount($Pref::Chat::BLIDsToFilter);%i++)
		{
			echo("   " @ getWord($Pref::Chat::BLIDsToFilter, %i));
		}
	}

	function clearIDFilter()
	{
		$Pref::Chat::BLIDsToFilter = "";
	}

	function clientCMDChatMessage(%client, %b, %c, %taggedString, %preTag, %name, %postTag, %message, %i)
	{
		if(getWordCount($Pref::Chat::BLIDsToFilter) > 0)
		{
			%allow = 1;

			for(%i = 0;%i < getWordCount($Pref::Chat::BLIDsToFilter);%i++)
			{
				%blids[getWord($Pref::Chat::BLIDsToFilter, %i)] = 1;
			}

			%row = NPL_List.getRowTextById(%client);
			%name = getField(%row, 1);
			%blid = getField(%row, 3);

			if(%blids[%blid])
			{
				Parent::clientCMDChatMessage(%client, %b, %c, "<font:Palatino Linotype:18>\c7" @ %preTag @ "\c3" @ %name @ "\c7" @ %postTag @ "\c6:\c0 Messages from this BLID are filtered per your preferences.", %preTag, %name, %postTag, "Messages from this BLID are filtered per your preferences.", %i);
			}
			else
			{
				Parent::clientCMDChatMessage(%client, %b, %c, %taggedString, %preTag, %name, %postTag, %message, %i);
			}
		}
		else
		{
			Parent::clientCMDChatMessage(%client, %b, %c, %taggedString, %preTag, %name, %postTag, %message, %i);
		}
	}
};

activatePackage(client_filterChatByBLID);